 /***************************************************************************************
 *This program is free software; you can redistribute it and/or modify					*
 * it under the terms of the GNU General Public License as published by					*
 * the Free Software Foundation; either version 2 of the License, or					*
 * (at your option) any later version.													*
 *																						*
 * The GPL can be found at: http://www.gnu.org/copyleft/gpl.html						*
 *																						*
 *																						*	
 ****************************************************************************************
 * Authors:																			  *
 *          Marc Dukette                                                              *
 **************************************************************************************/

#include "stdafx.h"

#ifdef __cplusplus
extern "C" {
#endif 

#ifndef SKIN_H
#define SKIN_H
#if (_WIN32_WCE >= 300 && !defined(HPC))
#define Y_ADJUST 0
#else
#define Y_ADJUST 25
#endif

typedef struct _SkinItem
{
	int type;
	int top;
	int left;
	int width;
	int height;
	int pushedtop;
	int pushedleft;
	int rotated;
	int status;
	int step;
	int bigstep;
	TCHAR font[100];
	int point;
	int FontRed;
	int FontGreen;
	int FontBlue;
	int BackRed;
	int BackGreen;
	int BackBlue;
	bool scrolltext;
}SkinItem;

typedef struct _Skin
{
	TCHAR BkgImg[255];
	TCHAR BtnImg[255];
	SkinItem ViewPort;
	SkinItem StopButton;
	SkinItem PlayButton;
	SkinItem FFWDButton;
	SkinItem InfoView;
	SkinItem SeekSlider;
	SkinItem SeekButton;
	SkinItem VolSlider;
	SkinItem VolButton;
	SkinItem RotateButton;
	SkinItem FullScreenButton;
	SkinItem EQButton;
	SkinItem RepeatButton;
	SkinItem NextButton;
	SkinItem PrevButton;
	SkinItem MuteButton;
	SkinItem OpenButton;
	SkinItem EditorButton;
	SkinItem Time;
	SkinItem PlaylistView;
	SkinItem MediaView;
} Skin;

void LoadSkin(LPTSTR FileName,HWND hWnd);
void ProcessRelease(int x,int y);
void ProcessPush(int x,int y);
void ProcessTrack(int x,int y);
void LoadSkinItem(LPSTR Name,SkinItem* Item);
void LoadSkinImages(LPTSTR Path);
void LoadSkinFile(LPTSTR FileName,HWND hWnd);
bool CheckRect(int x, int y, SkinItem* rc);

#endif
#ifdef __cplusplus
}
#endif 
